
package MyElements::graph_neighbours;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('graph_neighbours');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::GraphNeighboursRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::graph_neighbours

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
graph_neighbours from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::graph_neighbours->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::GraphNeighboursRequest
     output =>  $some_value, # string
     informat =>  $some_value, # string
     direction =>  $some_value, # string
     all =>  $some_value, # int
     stats =>  $some_value, # int
     self =>  $some_value, # int
     inputgraph =>  $some_value, # string
     seedfile =>  $some_value, # string
     wcol =>  $some_value, # int
     scol =>  $some_value, # int
     tcol =>  $some_value, # int
     steps =>  $some_value, # int
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

