
package MyElements::purge_seq;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('purge_seq');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::PurgeSequenceRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::purge_seq

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
purge_seq from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::purge_seq->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::PurgeSequenceRequest
     output =>  $some_value, # string
     sequence =>  $some_value, # string
     tmp_infile =>  $some_value, # string
     format =>  $some_value, # string
     match_length =>  $some_value, # int
     mismatch =>  $some_value, # int
     str =>  $some_value, # int
     delete =>  $some_value, # int
     mask_short =>  $some_value, # int
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

