
package MyElements::rnsc;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('rnsc');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::RNSCRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::rnsc

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
rnsc from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::rnsc->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::RNSCRequest
     output =>  $some_value, # string
     inputgraph =>  $some_value, # string
     max_clust =>  $some_value, # int
     tabulength =>  $some_value, # int
     tabulist =>  $some_value, # int
     naive_stop =>  $some_value, # int
     scale_stop =>  $some_value, # int
     exp_nb =>  $some_value, # int
     div_freq =>  $some_value, # int
     shf_div_len =>  $some_value, # int
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

