
package MyTypemaps::RSATWebServices;
use strict;
use warnings;

our $typemap_1 = {
               'dna_pattern/request/origin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/mean' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'mclResponse/response' => 'MyTypes::MCLResponse',
               'purge_seqResponse/response' => 'MyTypes::PurgeSequenceResponse',
               'convert_seqResponse' => 'MyElements::convert_seqResponse',
               'text_to_html/request/chunk' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'gene_info/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'text_to_htmlResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'mcl/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'parse_psi_xml/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membership/request/clusters' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'parse_psi_xml' => 'MyElements::parse_psi_xml',
               'text_to_htmlResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmapResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/return_fields' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/self' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_matrixResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan' => 'MyElements::matrix_scan',
               'convert_graphResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysisResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/non_coding' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/steps' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'supported_organismsResponse' => 'MyElements::supported_organismsResponse',
               'retrieve_seq_multigenome/request/nocom' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_node_degree/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'xygraph/request/xmin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map' => 'MyElements::feature_map',
               'get_orthologsResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/nogrep' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seq/request/sequence_length' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/mapthick' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_stats/request' => 'MyTypes::ContingencyStatsRequest',
               'retrieve_ensembl_seq/request/nogene' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'supported_organisms/request' => 'MyTypes::SupportedOrganismsRequest',
               'graph_topology/request/directed' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_topology' => 'MyElements::graph_topology',
               'get_orthologs/request/taxon' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topology/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'alter_graph/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/sort_distrib' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/max_genes' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dyad_analysis' => 'MyElements::dyad_analysis',
               'parse_psi_xml/request' => 'MyTypes::parsepsixmlRequest',
               'display_graph/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_stats' => 'MyElements::contingency_stats',
               'graph_neighbours/request/direction' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/directed' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/maxpat' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'classfreq/request/inputFile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seq/request/mismatch' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'text_to_htmlResponse' => 'MyElements::text_to_htmlResponse',
               'dna_pattern/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membershipResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features/request' => 'MyTypes::ConvertFeaturesRequest',
               'oligo_analysisResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operon/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_table/request/margin' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenome/request/lw' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighboursResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/right' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request/naive_stop' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/homology_type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/alphabet' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/ensembl_host' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degreeResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysisResponse' => 'MyElements::dyad_analysisResponse',
               'purge_seq/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'xygraph/request/xlog' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/legend' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/title' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/background_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_table/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/to_matrix' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_seq/request' => 'MyTypes::ConvertSeqRequest',
               'retrieve_seq/request/imp_pos' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'classfreq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_stats/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnscResponse/response' => 'MyTypes::RNSCResponse',
               'rnsc/request/shf_div_len' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_tableResponse/response' => 'MyTypes::ContingencyTableResponse',
               'compare_classesResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/noorf' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_get_clusters/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'classfreqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'text_to_htmlResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/bg_model' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_patternResponse' => 'MyElements::dna_patternResponse',
               'dyad_analysis/request/stats' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologsResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'get_resultResponse/response' => 'MyTypes::GetResultResponse',
               'graph_cluster_membership/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classesResponse' => 'MyElements::compare_classesResponse',
               'graph_get_clustersResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operonResponse/response' => 'MyTypes::InferOperonResponse',
               'monitorResponse/response' => 'MyTypes::MonitorResponse',
               'retrieve_seq_multigenome/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliquesResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_featuresResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assembly/request/toppat' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_get_clusters/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'classfreqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/inputFile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologsResponse' => 'MyElements::get_orthologsResponse',
               'dna_pattern/request/score' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/strand' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/utr' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysis/request/verbosity' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cluster_membership/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'gene_info/request/full' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cluster_membership/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/target' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seq/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distribResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/id' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scanResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_statsResponse/response' => 'MyTypes::RocStatsResponse',
               'graph_node_degreeResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliques/request/min_size' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/degree' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cluster_membership/request/stat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreq/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/verbosity' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq/request' => 'MyTypes::RetrieveSequenceRequest',
               'retrieve_ensembl_seqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/yleg1' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/eccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seq/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_neighbours/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix' => 'MyElements::convert_matrix',
               'supported_organisms/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degree/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/background_input' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphsResponse/response' => 'MyTypes::CompareGraphsResponse',
               'random_seq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysis/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membership/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_distrib/request/background_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'retrieve_seqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/feattype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topologyResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'parse_psi_xml/request/channels' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/infer_operons' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'roc_stats/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assembly/request/subst' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'Fault/faultstring' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/background_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'graph_get_clusters' => 'MyElements::graph_get_clusters',
               'display_graphResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operon/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'monitorResponse/response/status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/tmp_matrix_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seqResponse' => 'MyElements::retrieve_ensembl_seqResponse',
               'convert_graphResponse/response' => 'MyTypes::ConvertGraphResponse',
               'graph_get_clusters/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_classes/request/inputclasses' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_table/request/col1' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'parse_psi_xml/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'retrieve_ensembl_seq/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnsc/request/div_freq' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_matrixResponse/response' => 'MyTypes::ConvertMatrixResponse',
               'random_seq/request' => 'MyTypes::RandomSequenceRequest',
               'contingency_statsResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreq/request' => 'MyTypes::ClassFreqRequest',
               'mclResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/upper_threshold_field' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs' => 'MyElements::get_orthologs',
               'graph_topology/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/select' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib/request/background_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/line_width' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_matrix/request/decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/maxfthick' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_node_degree/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clustersResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/score_column' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph/request/eccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/background_window' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern' => 'MyElements::dna_pattern',
               'gene_infoResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request' => 'MyTypes::GetOrthologsRequest',
               'xygraph/request/xcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/perm' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'text_to_html/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/distinct' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'mcl' => 'MyElements::mcl',
               'matrix_distrib/request/matrix_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/add_edges' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/layout' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_distribResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/dot' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seq' => 'MyElements::random_seq',
               'contingency_statsResponse/response' => 'MyTypes::ContingencyStatsResponse',
               'retrieve_ensembl_seq/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_mapResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraphResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/rc' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'supported_organismsResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membershipResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/sccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dyad_analysis/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_patternResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/min_score' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/max_profile' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/repeat' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_node_degree/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cliquesResponse' => 'MyElements::graph_cliquesResponse',
               'convert_featuresResponse/response' => 'MyTypes::ConvertFeaturesResponse',
               'feature_map/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Qscol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/score_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graph/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graphResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operon/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/lw' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/crer_ids' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib/request/background' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assembly/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cluster_membership/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysisResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'get_result' => 'MyElements::get_result',
               'contingency_statsResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/input' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysisResponse/response' => 'MyTypes::OligoAnalysisResponse',
               'convert_graph/request/tccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_get_clusters/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliques/request' => 'MyTypes::GraphCliquesRequest',
               'infer_operon/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/feattype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/undirected' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cliques' => 'MyElements::graph_cliques',
               'mcl/request' => 'MyTypes::MCLRequest',
               'convert_seqResponse/response' => 'MyTypes::ConvertSeqResponse',
               'retrieve_seq_multigenomeResponse' => 'MyElements::retrieve_seq_multigenomeResponse',
               'convert_featuresResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membership/request' => 'MyTypes::GraphClusterMembershipRequest',
               'roc_stats/request' => 'MyTypes::RocStatsRequest',
               'display_graph/request/layout' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operonResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/noorf' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seq/request/mask_short' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq' => 'MyElements::retrieve_seq',
               'graph_get_clustersResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Qtcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnsc' => 'MyElements::rnsc',
               'compare_classes/request/lower_threshold_value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/query_classes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmap/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topology/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_classes/request/names' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seqResponse' => 'MyElements::retrieve_seqResponse',
               'retrieve_seq/request/label' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph' => 'MyElements::random_graph',
               'convert_graph/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'monitor/request' => 'MyTypes::MonitorRequest',
               'matrix_scan/request' => 'MyTypes::MatrixScanRequest',
               'contingency_table/request/col2' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_graphsResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distribResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/origin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/top_matrices' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_patternResponse/response' => 'MyTypes::DnaPatternResponse',
               'classfreq/request/classinterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membershipResponse' => 'MyElements::graph_cluster_membershipResponse',
               'xygraph/request/ycol' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discoveryResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graphResponse/response' => 'MyTypes::DisplayGraphResponse',
               'random_graph/request/no_single' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'draw_heatmapResponse/response' => 'MyTypes::DrawHeatmapResponse',
               'roc_stats/request/lcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'get_resultResponse' => 'MyElements::get_resultResponse',
               'contingency_tableResponse' => 'MyElements::contingency_tableResponse',
               'retrieve_seq_multigenome/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_seq/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request' => 'MyTypes::FeatureMapRequest',
               'compare_classes' => 'MyElements::compare_classes',
               'dyad_analysis/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_stats/request/rsizes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysisResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/maxscore' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/sequence_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/ecolors' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/lines' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request' => 'MyTypes::ConvertGraphRequest',
               'feature_map/request/scalebar' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operon/request' => 'MyTypes::InferOperonRequest',
               'get_orthologs/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/label' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topologyResponse/response' => 'MyTypes::GraphTopologyResponse',
               'graph_topology/request' => 'MyTypes::GraphTopologyRequest',
               'convert_graphResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/ortho' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'supported_organismsResponse/response' => 'MyTypes::SupportedOrganismsResponse',
               'graph_cliques/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'Fault/faultcode' => 'SOAP::WSDL::XSD::Typelib::Builtin::anyURI',
               'random_graph/request' => 'MyTypes::RandomGraphRequest',
               'graph_topology/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'mcl/request/inflation' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'compare_graphs/request/Rscol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graph/request/target_xpos_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_statsResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Qwcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/label' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/sep_genes' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_patternResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib/request/matrix_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assemblyResponse/response' => 'MyTypes::PatternAssemblyResponse',
               'retrieve_seq_multigenome/request/org_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assemblyResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request' => 'MyTypes::RNSCRequest',
               'random_seq/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/repetition' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighboursResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'monitor/request/ticket' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'monitorResponse' => 'MyElements::monitorResponse',
               'convert_features/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_result/request' => 'MyTypes::GetResultRequest',
               'draw_heatmapResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'text_to_html/request/font' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request/descr' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graphResponse/response' => 'MyTypes::RandomGraphResponse',
               'display_graphResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'text_to_html/request/no_sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request' => 'MyTypes::OligoAnalysisRequest',
               'convert_matrix/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topologyResponse' => 'MyElements::graph_topologyResponse',
               'matrix_scanResponse' => 'MyElements::matrix_scanResponse',
               'parse_psi_xmlResponse/response' => 'MyTypes::parsepsixmlResponse',
               'oligo_analysis/request/pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysisResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/chromosome' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'Fault/detail' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/score_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_node_degree/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classesResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_patternResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'graph_neighbours/request/stats' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnsc/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/header_organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'supported_organismsResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request' => 'MyTypes::CompareClassesRequest',
               'retrieve_seq_multigenomeResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/orientation' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/member_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_neighboursResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreqResponse' => 'MyElements::classfreqResponse',
               'graph_node_degreeResponse/response' => 'MyTypes::GraphNodeDegreeResponse',
               'alter_graph/request/rm_edges' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features' => 'MyElements::convert_features',
               'pattern_assembly/request' => 'MyTypes::PatternAssemblyRequest',
               'convert_graph/request/target_ypos_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scanResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliques/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operonResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graphResponse/response' => 'MyTypes::AlterGraphResponse',
               'xygraph/request/ylog' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/tmp_input_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_tableResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/clusters' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/repeat' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenome/request/type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_neighboursResponse' => 'MyElements::graph_neighboursResponse',
               'retrieve_ensembl_seq/request/mask_coding' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operon' => 'MyElements::infer_operon',
               'monitor' => 'MyElements::monitor',
               'random_graph/request/edges' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discoveryResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/xmax' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features/request/input' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/induced' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'mclResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classesResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operon/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_mapResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/all_transcripts' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_table/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraphResponse' => 'MyElements::xygraphResponse',
               'footprint_discovery/request/no_filter' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/return_fields' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_mapResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/directed' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'roc_stats' => 'MyElements::roc_stats',
               'draw_heatmap/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'text_to_html/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degree/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/noov' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graph/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/tmp_sequence_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/unique_sequences' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/features' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Rinputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/taxon' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topology/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnscResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request/tabulist' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_matrixResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operonResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classesResponse/response' => 'MyTypes::ConvertClassesResponse',
               'matrix_scan/request/background_model' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/features' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery' => 'MyElements::footprint_discovery',
               'oligo_analysis/request/length' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seq/request/expfreq' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membership' => 'MyElements::graph_cluster_membership',
               'retrieve_seq/request/label_sep' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/duplicate' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'roc_statsResponse' => 'MyElements::roc_statsResponse',
               'matrix_distrib/request/decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request' => 'MyTypes::RetrieveEnsemblSequenceRequest',
               'classfreqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_result/request/ticket' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/label_sep' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/rm_nodes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_infoResponse' => 'MyElements::gene_infoResponse',
               'text_to_html/request' => 'MyTypes::TextToHtmlRequest',
               'parse_psi_xml/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'random_seq/request/oligo_length' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seqResponse/response' => 'MyTypes::RetrieveEnsemblSequenceResponse',
               'feature_map/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'mclResponse' => 'MyElements::mclResponse',
               'random_seq/request/line_width' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graphResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request/scale_stop' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scanResponse/response' => 'MyTypes::MatrixScanResponse',
               'graph_cluster_membership/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degree/request' => 'MyTypes::GraphNodeDegreeRequest',
               'rnscResponse' => 'MyElements::rnscResponse',
               'alter_graphResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classesResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'mcl/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_featuresResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Qinputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliquesResponse/response' => 'MyTypes::GraphCliquesResponse',
               'compare_classes/request/matrix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graphResponse' => 'MyElements::random_graphResponse',
               'graph_cluster_membershipResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliquesResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib' => 'MyElements::matrix_distrib',
               'retrieve_ensembl_seq/request/first_intron' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dyad_analysis/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/spacing' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'supported_organismsResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/pathcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operon/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_seq/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/base' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/distinct' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_classesResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request' => 'MyTypes::DnaPatternRequest',
               'parse_psi_xmlResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clustersResponse' => 'MyElements::graph_get_clustersResponse',
               'draw_heatmapResponse' => 'MyElements::draw_heatmapResponse',
               'retrieve_seq_multigenome/request' => 'MyTypes::RetrieveSequenceMultigenomeRequest',
               'dna_pattern/request/pattern' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/title2' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request' => 'MyTypes::AlterGraphRequest',
               'retrieve_ensembl_seq/request/db_name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs' => 'MyElements::compare_graphs',
               'draw_heatmap/request/max' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'gene_info' => 'MyElements::gene_info',
               'graph_neighboursResponse/response' => 'MyTypes::GraphNeighboursResponse',
               'feature_map/request/scorethick' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graph/request/source_xpos_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discoveryResponse' => 'MyElements::footprint_discoveryResponse',
               'Fault' => 'SOAP::WSDL::SOAP::Typelib::Fault11',
               'convert_seq/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysisResponse' => 'MyElements::oligo_analysisResponse',
               'classfreq/request/max' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_features/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_table' => 'MyElements::contingency_table',
               'matrix_scan/request/verbosity' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/left' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_get_clusters/request' => 'MyTypes::GraphGetClustersRequest',
               'convert_graph/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_graphs/request/Qinformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/bg_model' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Rinformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distrib/request/matrix_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/index' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seq/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seq/request/match_length' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_topologyResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologsResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliques/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/symbol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenomeResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnscResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/length' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/max_asmb_size' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/lth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request/tabulength' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'gene_infoResponse/response' => 'MyTypes::GeneInfoResponse',
               'display_graph/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/genes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/th' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/minscore' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/mono' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_distrib/request/tmp_matrix_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreq/request/col' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degree/request/nodefile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologsResponse/response' => 'MyTypes::GetOrthologsResponse',
               'contingency_tableResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenome/request/gene_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'parse_psi_xmlResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmapResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request' => 'MyTypes::GeneInfoRequest',
               'convert_graph/request/distinct_path' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnsc/request/exp_nb' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_seq/request/type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysis' => 'MyElements::oligo_analysis',
               'display_graph/request' => 'MyTypes::DisplayGraphRequest',
               'alter_graph/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_statsResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_seq/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/tmp_sequence_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph' => 'MyElements::xygraph',
               'oligo_analysis/request/stats' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'parse_psi_xmlResponse' => 'MyElements::parse_psi_xmlResponse',
               'convert_seqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topology/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphsResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distribResponse' => 'MyElements::matrix_distribResponse',
               'convert_matrixResponse' => 'MyElements::convert_matrixResponse',
               'convert_seqResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assemblyResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_seq' => 'MyElements::convert_seq',
               'feature_map/request/minfthick' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'xygraphResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topology/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graphResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysis/request/str' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'footprint_discovery/request/output_prefix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seqResponse' => 'MyElements::random_seqResponse',
               'get_resultResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_statsResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/lower_threshold_field' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/two_tails' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'infer_operonResponse' => 'MyElements::infer_operonResponse',
               'retrieve_ensembl_seq/request/noorf' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_cliquesResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq_multigenomeResponse/response' => 'MyTypes::RetrieveSequenceMultigenomeResponse',
               'alter_graphResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/equi_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_classes/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degree/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_table/request/null' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/col_conservation' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'draw_heatmap/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/all_genes' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph' => 'MyElements::display_graph',
               'supported_organisms' => 'MyElements::supported_organisms',
               'gene_infoResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_stats/request/total' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/seedfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/random_type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph' => 'MyElements::convert_graph',
               'convert_matrixResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request/sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/input_classes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/mlen' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_classes/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graphResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_stats/request/status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/title1' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_table/request' => 'MyTypes::ContingencyTableRequest',
               'alter_graphResponse' => 'MyElements::alter_graphResponse',
               'display_graph/request/ewidth' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/matrix_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request/feattype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classesResponse' => 'MyElements::convert_classesResponse',
               'compare_graphs/request/self' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'oligo_analysis/request/noov' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scanResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'contingency_stats/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/n_treatment' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmap' => 'MyElements::draw_heatmap',
               'footprint_discovery/request/taxon' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_neighbours/request/self' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_featuresResponse' => 'MyElements::convert_featuresResponse',
               'compare_graphs/request/Rtcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/mspacing' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_classes/request/sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/htmap' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seqResponse' => 'MyElements::purge_seqResponse',
               'graph_cliques/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_matrix/request/top' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_ensembl_seq/request/feat_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graphResponse' => 'MyElements::display_graphResponse',
               'graph_neighbours/request' => 'MyTypes::GraphNeighboursRequest',
               'alter_graph/request/add_nodes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/seed' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_graphs/request' => 'MyTypes::CompareGraphsRequest',
               'footprint_discovery/request/verbosity' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assemblyResponse' => 'MyElements::pattern_assemblyResponse',
               'retrieve_seq/request/feattype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphsResponse' => 'MyElements::compare_graphsResponse',
               'matrix_scan/request/background_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'retrieve_seq/request/nocom' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graphResponse' => 'MyElements::convert_graphResponse',
               'contingency_stats/request/csizes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/duplicate' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_distrib/request' => 'MyTypes::MatrixDistribRequest',
               'convert_matrix/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seq/request' => 'MyTypes::PurgeSequenceRequest',
               'retrieve_ensembl_seq/request/to' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'matrix_scan/request/tmp_background_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graph/request/sccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenome/request/imp_pos' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'roc_stats/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/source_ypos_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern/request/subst' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_stats/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/equi_pseudo' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/max_asmb_nb' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern/request/pattern_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'oligo_analysis/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmap/request/no_text' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'contingency_statsResponse' => 'MyElements::contingency_statsResponse',
               'convert_matrix/request/matrix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/tcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnsc/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_distribResponse/response' => 'MyTypes::MatrixDistribResponse',
               'convert_matrix/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assembly/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discoveryResponse/response' => 'MyTypes::FootprintDiscoveryResponse',
               'compare_graphs/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request' => 'MyTypes::FootprintDiscoveryRequest',
               'dyad_analysisResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discoveryResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/legend' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'draw_heatmap/request/min' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_node_degree' => 'MyElements::graph_node_degree',
               'oligo_analysis/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cliques/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request' => 'MyTypes::ConvertClassesRequest',
               'graph_node_degreeResponse' => 'MyElements::graph_node_degreeResponse',
               'text_to_htmlResponse/response' => 'MyTypes::TextToHtmlResponse',
               'parse_psi_xml/request/interactor_type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clustersResponse/response' => 'MyTypes::GraphGetClustersResponse',
               'retrieve_seq_multigenome' => 'MyElements::retrieve_seq_multigenome',
               'xygraph/request/ymin' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphs/request/Rwcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'gene_infoResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_node_degreeResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_graphsResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/background' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seqResponse/response' => 'MyTypes::RandomSequenceResponse',
               'contingency_stats/request/decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'Fault/faultactor' => 'SOAP::WSDL::XSD::Typelib::Builtin::token',
               'xygraphResponse/response' => 'MyTypes::XYGraphResponse',
               'draw_heatmap/request/row_names' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly/request/verbosity' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_classes/request/upper_threshold_value' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classesResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graph/request/scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assembly' => 'MyElements::pattern_assembly',
               'contingency_tableResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/xleg2' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classesResponse/response' => 'MyTypes::CompareClassesResponse',
               'retrieve_seqResponse/response' => 'MyTypes::RetrieveSequenceResponse',
               'retrieve_seq_multigenomeResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/uth' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request' => 'MyTypes::XYGraphRequest',
               'graph_topology/request/nodefile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/consensus_name' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmap/request/gradient' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'draw_heatmap/request' => 'MyTypes::DrawHeatmapRequest',
               'purge_seq/request/delete' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'purge_seqResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_seq/request/all' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'classfreqResponse/response' => 'MyTypes::ClassFreqResponse',
               'convert_seq/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/markov' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/origin' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_seqResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'infer_operon/request/distance' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'xygraph/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq' => 'MyElements::retrieve_ensembl_seq',
               'random_graphResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request' => 'MyTypes::DyadAnalysisRequest',
               'contingency_stats/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_topologyResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'parse_psi_xml/request/inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'alter_graph' => 'MyElements::alter_graph',
               'footprint_discovery/request/dist_thr' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_neighbours/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_mapResponse' => 'MyElements::feature_mapResponse',
               'oligo_analysis/request/background' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/ymax' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/matrix' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/type' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'text_to_html' => 'MyElements::text_to_html',
               'convert_classes' => 'MyElements::convert_classes',
               'pattern_assembly/request/maxfl' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_map/request/tmp_infile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'pattern_assemblyResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'compare_classes/request/ref_classes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dna_pattern/request/sort' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'draw_heatmap/request/row_height' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern/request/noov' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreq/request/min' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'classfreq' => 'MyElements::classfreq',
               'matrix_scan/request/sequence' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'matrix_scan/request/background' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'rnsc/request/max_clust' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'display_graph/request/tccol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'parse_psi_xmlResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/length_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'purge_seq' => 'MyElements::purge_seq',
               'draw_heatmap/request/col_width' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'alter_graph/request/inputgraph' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'display_graph/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'alter_graph/request/wcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'get_resultResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'supported_organisms/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'roc_statsResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/sd' => 'SOAP::WSDL::XSD::Typelib::Builtin::float',
               'dyad_analysis/request/under' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenome/request/repeat' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'random_graph/request/directed' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'retrieve_seq_multigenome/request/input' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/normal' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'draw_heatmap/request/html' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_classes/request/triangle' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'compare_graphs/request/outweight' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_graph/request/nodes' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dyad_analysis/request/format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/header' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'xygraphResponse/response/client' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'pattern_assembly/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_get_clusters/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_classes/request/class_col' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'random_seq/request/tmp_expfreq_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membership/request/decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'dna_pattern/request/tmp_pattern_file' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/scalestep' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'graph_topology/request/informat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'get_orthologs/request/query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'supported_organisms/request/taxon' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'footprint_discovery/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'xygraph/request/yleg2' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysisResponse/response' => 'MyTypes::DyadAnalysisResponse',
               'classfreq/request/from' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'dyad_analysis/request/zeroocc' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'feature_mapResponse/response' => 'MyTypes::FeatureMapResponse',
               'dna_pattern/request/output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_matrix/request' => 'MyTypes::ConvertMatrixRequest',
               'convert_graph/request/outformat' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'retrieve_ensembl_seq/request/organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'gene_info/request/noquery' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'rnscResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'convert_graph/request/ewidth' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
               'convert_graphResponse/response/server' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_cluster_membershipResponse/response' => 'MyTypes::GraphClusterMembershipResponse',
               'xygraph/request/xleg1' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'graph_neighbours' => 'MyElements::graph_neighbours',
               'mclResponse/response/command' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
               'feature_map/request/sequence_format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string'
             };
;

sub get_class {
  my $name = join '/', @{ $_[1] };
  exists $typemap_1->{ $name } or die "Cannot resolve $name via " . __PACKAGE__;
  return $typemap_1->{ $name };
}

sub get_typemap {
    return $typemap_1;
}

1;

__END__

__END__

=pod

=head1 NAME

MyTypemaps::RSATWebServices - typemap for RSATWebServices

=head1 DESCRIPTION

Typemap created by SOAP::WSDL for map-based SOAP message parsers.

=cut

