package MyTypes::ContingencyStatsRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %inputfile_of :ATTR(:get<inputfile>);
my %decimals_of :ATTR(:get<decimals>);
my %return_of :ATTR(:get<return>);
my %rsizes_of :ATTR(:get<rsizes>);
my %csizes_of :ATTR(:get<csizes>);

__PACKAGE__->_factory(
    [ qw(        output
        inputfile
        decimals
        return
        rsizes
        csizes

    ) ],
    {
        'output' => \%output_of,
        'inputfile' => \%inputfile_of,
        'decimals' => \%decimals_of,
        'return' => \%return_of,
        'rsizes' => \%rsizes_of,
        'csizes' => \%csizes_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'decimals' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'return' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'rsizes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'csizes' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'output' => 'output',
        'inputfile' => 'inputfile',
        'decimals' => 'decimals',
        'return' => 'return',
        'rsizes' => 'rsizes',
        'csizes' => 'csizes',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ContingencyStatsRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ContingencyStatsRequest from the namespace urn:RSATWS.

Parameters for the operation contingency-stats.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * inputfile


=item * decimals


=item * return


=item * rsizes


=item * csizes




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ContingencyStatsRequest
   output =>  $some_value, # string
   inputfile =>  $some_value, # string
   decimals =>  $some_value, # int
   return =>  $some_value, # string
   rsizes =>  $some_value, # string
   csizes =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

