package MyTypes::ContingencyTableRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %inputfile_of :ATTR(:get<inputfile>);
my %col1_of :ATTR(:get<col1>);
my %col2_of :ATTR(:get<col2>);
my %margin_of :ATTR(:get<margin>);
my %null_of :ATTR(:get<null>);

__PACKAGE__->_factory(
    [ qw(        output
        inputfile
        col1
        col2
        margin
        null

    ) ],
    {
        'output' => \%output_of,
        'inputfile' => \%inputfile_of,
        'col1' => \%col1_of,
        'col2' => \%col2_of,
        'margin' => \%margin_of,
        'null' => \%null_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'col1' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'col2' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'margin' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'null' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
    },
    {

        'output' => 'output',
        'inputfile' => 'inputfile',
        'col1' => 'col1',
        'col2' => 'col2',
        'margin' => 'margin',
        'null' => 'null',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ContingencyTableRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ContingencyTableRequest from the namespace urn:RSATWS.

Parameters for the operation contingency_table.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * inputfile


=item * col1


=item * col2


=item * margin


=item * null




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ContingencyTableRequest
   output =>  $some_value, # string
   inputfile =>  $some_value, # string
   col1 =>  $some_value, # int
   col2 =>  $some_value, # int
   margin =>  $some_value, # int
   null =>  $some_value, # int
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

