package MyTypes::RocStatsRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %inputfile_of :ATTR(:get<inputfile>);
my %scol_of :ATTR(:get<scol>);
my %lcol_of :ATTR(:get<lcol>);
my %status_of :ATTR(:get<status>);
my %total_of :ATTR(:get<total>);

__PACKAGE__->_factory(
    [ qw(        output
        inputfile
        scol
        lcol
        status
        total

    ) ],
    {
        'output' => \%output_of,
        'inputfile' => \%inputfile_of,
        'scol' => \%scol_of,
        'lcol' => \%lcol_of,
        'status' => \%status_of,
        'total' => \%total_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'inputfile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'scol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'lcol' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'status' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'total' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
    },
    {

        'output' => 'output',
        'inputfile' => 'inputfile',
        'scol' => 'scol',
        'lcol' => 'lcol',
        'status' => 'status',
        'total' => 'total',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::RocStatsRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
RocStatsRequest from the namespace urn:RSATWS.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * inputfile


=item * scol


=item * lcol


=item * status


=item * total




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::RocStatsRequest
   output =>  $some_value, # string
   inputfile =>  $some_value, # string
   scol =>  $some_value, # int
   lcol =>  $some_value, # int
   status =>  $some_value, # string
   total =>  $some_value, # int
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

