package MyTypes::SupportedOrganismsRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %format_of :ATTR(:get<format>);
my %taxon_of :ATTR(:get<taxon>);

__PACKAGE__->_factory(
    [ qw(        output
        format
        taxon

    ) ],
    {
        'output' => \%output_of,
        'format' => \%format_of,
        'taxon' => \%taxon_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'format' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'taxon' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'output' => 'output',
        'format' => 'format',
        'taxon' => 'taxon',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::SupportedOrganismsRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
SupportedOrganismsRequest from the namespace urn:RSATWS.

Parameters for the operation supported_organisms.




=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * format


=item * taxon




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::SupportedOrganismsRequest
   output =>  $some_value, # string
   format =>  $some_value, # string
   taxon =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

