#!/usr/bin/env perl
#### this cgi script fills the HTML form for the program varition-scan
BEGIN {
    if ($0 =~ /([^(\/)]+)$/) {
	push (@INC, "$`lib/");
    }
    require "RSA.lib";
}
#if ($0 =~ /([^(\/)]+)$/) {
#    push (@INC, "$`lib/");
#}
use CGI;
use CGI::Carp qw/fatalsToBrowser/;
require "RSA.lib";
require "RSA2.cgi.lib";
require "matrix_web_forms.lib.pl";
use RSAT::MatrixReader;
$ENV{RSA_OUTPUT_CONTEXT} = "cgi";

### Read the CGI query
$query = new CGI;

################################################################
## Default values for filling the form

## matrix-scan
$default{demo_descr1} = "";
$default{matrix}="";
$default{matrix_file}="";
$default{matrix_format} = "transfac";
$default{pseudo_distribution} = "pseudo_prior";
$checked{$default{pseudo_distribution}} = "CHECKED";
$default{mml}=30;

#$default{compare_motif_database}="jaspar_core_nonredundant_vertebrates";
#$default{db_choice_set}="jaspar_core_nonredundant_vertebrates";
#$default{custom_motif_db_name}="custom_motif_collection";

## Threshold values for site detection
## Suported uth
$default{uth_pval} = "1e-3";

## Suported lth
$default{lth_score} = "1";
$default{lth_w_diff} = "1";
$default{lth_pval_ratio} = "10";


## Background model
$default{markov_order} = "1";

$default{leaders} = 'checked';
$default{bg_method}="bgfile";
$checked{$default{bg_method}} = "CHECKED";
$default{organism}="";
#$default{organism}="Homo_sapiens";
$default{pseudo_freq} = "0.01";



### replace defaults by parameters from the cgi call, if defined
foreach $key (keys %default) {
  if ($query->param($key)) {
    $default{$key} = $query->param($key);
  }
   if ($query->param($key) =~ /checked/i) {
    $checked{$key} = "CHECKED";
  }
  if ($key eq "visualize"){
  	$checked{$query->param($key)} = "CHECKED";
  }
}



################################################################
### print the form ###

################################################################
### header
&RSA_header("variation-scan", "form");
print "<CENTER>";
print "Scan sequences of polymorphic variants with a list of motifs to predict transcription factor binding sites (TFBS) affected by the variations.<br/>\n";
print "<br>Conception<sup>c</sup>, implementation<sup>i</sup> and testing<sup>t</sup>:</br> ";
print "<a target='_blank' href='http://jacques.van-helden.perso.luminy.univ-amu.fr//'>Jacques van Helden</a><sup>cit</sup>\n";
print ", <a target='_blank' href='http://liigh.unam.mx/amedina/index.html'>Alejandra Medina-Rivera</a><sup>cit</sup>\n";
print ", <a target='_blank' href='http://liigh.unam.mx/amedina/people.html'>Walter Santana</a><sup>cit</sup>\n";
print ", Jeremy Delerce<sup>ci</sup>\n";
print "</CENTER>";
print "</BLOCKQUOTE>\n";

################################################################
## Display the form only if this RSAT instance supports variation
## analysis.
&check_variation_tools();

################################################################
### formheader

print "<div class=\"menu_heading_closed\" onclick=\"toggleMenu(\'105\')\" id=\"heading105\"><font color='#0D73A7'>Information about variation-scan</font> </div>\n";
 print "<div id=\"menu105\" class=\"menu_collapsible\">\n";
print "<BLOCKQUOTE>\n";
print "<p>Scan variant sequences with position specific scoring matrices (PSSM)
    and report variations that affect the binding score, in order to predict
    regulatory variants.</p> ";
print "</BLOCKQUOTE>\n";
print "</div></p>\n";

&ListParameters() if ($ENV{rsat_echo} >=2);

#&ReadMatrixFromFile() ;

## Demo description
#print $default{demo_descr1};
print "<div id='demo_descr'></div>";

print $query->start_multipart_form(-action=>"variation-scan.cgi", -onreset=>"resetHandler()");

################# Matrix input
 &Panel1();


################# Input variant sequences
 &Panel2();

################# Scanning Parameters
 &Panel3();

################# Drawing parameters
##&Panel4();



################################################################
## Select output mode. Email is preferred since footprint discovery
## may take a while.
print "<p>\n";
&SelectOutput('email');

################################################################
### action buttons
print "<UL><UL><TABLE class='formbutton'>\n";
print "<TR VALIGN=MIDDLE>\n";
print "<TD>", $query->submit(-label=>"GO"), "</TD>\n";
print "<TD>", $query->reset, "</TD>\n";
print $query->end_form;

################################################################
### data for the demo

my $descr1 = "<H4>Comment on the demonstration :</H4>\n";
$descr1 .= "<blockquote class ='demo'>";
$descr1 .= "<p>In this demonstration, we use <i>variation-scan<\i> to assess the effect that a genetic variants have on transcription factor binding.</p>\n
<p> The genetic variants used in this example were collected by Weirauch, et al (Cell, 2014), these variants were reported in previous publications as affecting transcription factor binding. Motifs correspond to the transcription factores which biniding was reported to be affected by Weirauch, et al.</p>\n";
$descr1 .= "</blockquote>";

print $query->start_multipart_form(-action=>"variation-scan_form.cgi");
print $query->hidden(-name=>'queries',-default=>$demo_queries);
print $query->hidden(-name=>'organism',-default=>"Homo_sapiens_GRCh37");

$demo_matrix_file="demo_files/variation_demo_set_MWeirauch_cell_2014_15SNPs_TFs.tf";
$demo_matrix = "";
open(my $fh, $demo_matrix_file);
while(my $row = <$fh>){
    chomp $row;
    $demo_matrix .= $row;
    $demo_matrix .= "\\n";
}

$demo_var_file="demo_files/variation_demo_set_MWeirauch_cell_2014_15SNPs.varseq";
$demo_var_seq = "";
open(my $fh, $demo_var_file);
while(my $row = <$fh>){
    chomp $row;
    $demo_var_seq .= $row;
    $demo_var_seq .= "\\n";
}

$demo_bg_url= $ENV{rsat_www}."/demo_files/all_human_ENCODE_DNAse_mk1_bg.ol";


print "<TD><b>";

print '<script>
$(function(){
    $("input[name=db_choice_radio]").change(function(){
        if($("input[name=db_choice_radio][value=custom_motif_db]").is(":checked")){
            $("#db_choice2").val("").change();
        }
    });
});

function setDemo(){
    $("#reset").trigger("click");

    descr1 = "<H4>Comment on the demonstration :</H4>\n \
    <blockquote class =\'demo\'> \
    <p>In this demonstration, we use <i>variation-scan<\i> to assess the effect that a genetic variants have on transcription factor binding.</p>\n \
    <p> The genetic variants used in this example were collected by Weirauch, et al (Cell, 2014), these variants were reported in previous publications as affecting transcription factor binding. Motifs correspond to the transcription factores which biniding was reported to be affected by Weirauch, et al.</p>\n \
    </blockquote>";

    demo_descr.innerHTML = descr1;
    $("input[name=db_choice_radio][value=\'custom_motif_db\']").prop("checked", true).change();
    matrix.value = "' . $demo_matrix . '";
    matrix_format.value = "transfac";
    variants_seqs.value = "' . $demo_var_seq . '";
    $("#bg_method_background").prop("checked", true);
    $("[name=\'background\']").val("upstream-noorf");
    markov_order.value = 2;

    $("#url").prop("checked",true);
    bgmodel_url.value =   "' . $demo_bg_url . '";

}
</script>';

print '<button type="button" onclick="setDemo()">DEMO</button>';

print '<script>function resetHandler(){
$("#db_choice").val("").change();
$("#db_choice2").val("").change();
}</script>';

print "</B></TD>\n";
print $query->end_form;


##print "<td><b><a href='tutorials/tut_peak_motif.html'>[TUTORIAL]</a></B></TD>\n";
print "<td><b><a href='sample_outputs/variation-scan_demo20180322.variants-seq_result'>[Sample Output]</a></B></TD>\n";
print "<td><b><a href='help.variation-scan.html'>MANUAL</a></B></TD>\n";

#print "<td><b><a href='tutorials/tut_peak-motifs.html'>[TUTORIAL]</a></B></TD>\n";
#print "<TD><b><a href='http://www.bigre.ulb.ac.be/forums/' target='_top'>[ASK A QUESTION]</a></B></TD>\n";
print "</TR></TABLE></UL></UL>\n";
print "<br><br><font size=1 color=\"grey\" ><small>AMR and WS are supported by a PAPIIT-UNAM (IA206517) grant.</small></font>";

print "</FONT>\n";



print $query->end_html;

exit(0);



#################### Internal functions #######################

# sub Panel1 {

#   print "<fieldset>\n<legend><b><a href='help.formats.html'>Matrix </a></b></legend>\n";

#   &GetMatrix();

#   print '<b><font style="font-size:80%"><a href="tutorials/tut_peak-motifs.html#seq" target="_blank"></a></font></b></br>';
#   print "</fieldset><p/>";
# }

################################################################
## Select motif data base to be used to scan variants

sub Panel1 {
  print '<br/>';
#<div>' #  print "
# <div class=\"menu_heading_closed\" onclick=\"toggleMenu('103')\" id=\"heading103\">

#  <span title=\"A set conformed by different motifs representing binding profiles for several transcription factors will be used to scan the variants. Select here the known motifs collection or provide your own.\"></span> </div>\n
# <div id=\"menu103\" class=\"menu_collapsible\">";

  ## Tasks
  print "<fieldset><legend><a href='help.variation-scan.html#Matrix-collections'><b>Matrix collections</b></a></legend>";


  print "<p/> ";
  print "<b>A set conformed by different motifs representing binding profiles for several transcription factors will be used to scan the variants. Provide your own motifs collection or select one to be used.</b><br/>";
   print "<BR>\n";


  ## Old code to input the motif database via file or url
  # print "<input type='radio' NAME='db_choice' VALUE='custom_motif_db' $checked{file_upload}>";
  # print "<a href=''><b>Use your own motif database file:</b></a><br/>";
  # print $query->filefield(-name=>'custom_motif_db_txt',
  # 			  -size=>10);
  # print "<p/> ";
  # print "<input type='radio' NAME='db_choice' VALUE='custom_motif_db_url' >";
  # print "<a href=''><b>Use your own motif database from URL source:</b></a><br/>";
  # print $query->textfield(-name=>'custom_motif_db_url_txt',
  # 		  -default=>$default{'custom_motif_db_url'},
  # 						-size=>62);

  my %matrix_args= (
      'db_choice'=>1,
      'no_pseudo'=>1,
      'status_db_choice'=>"checked"
      );

  &GetMatrix(%matrix_args);


  ## load the various databases that can be compared against
  print "<p/>";
  print "<input type='radio' NAME='db_choice_radio' VALUE='motif_collection_all' >";
  print "<b>Select one motif collection</b><img src='images/onebit_49.png' height='30' class='new'/>";
  &MotifSelection("mode"=>"radio", "more" => 1);
  print "<p/> ";

  print '<script>
  $(function(){
      $("#db_choice2").change(function(){
          if($("#db_choice2").val() != ""){
              $("input[name=db_choice][value=\'custom_motif_db\']").prop("checked", false);
          }
      });
      $("input[name=db_choice][value=\'custom_motif_db\']").change(function(){
          $("#db_choice2").val("").change();
      });
  });

  </script>';

  print "</fieldset><p/>";

  print '</div><p class="clear"></p>';
}

##########################################
sub Panel2 {
  print "<p class=\"clear\"></p>\n";
 # print "<div class=\"menu_heading_open\" onclick=\"toggleMenu(\'101\')\" id=\"heading101\"><b>Variant Sequence</b> </div>\n";
  print "<div id=\"menu101\" class=\"menu_collapsible_display\">\n";

  print "<p/><fieldset>\n";
  print "<legend><b><a href='help.variation-scan.html#Sequence-file'>Input variation sequences</a></b></legend>\n";


### Input variant-seqs
  print "<br>";
  print "<A HREF='help.variation-scan.html#input'><B>\n";
  print "Variant sequences</p>";
  print "</B></A>\n";
  if ($variants_seq_file = $query->param('variants_seq_file')) {
      ## Variants_Seq file is already on the server machine
      ## (piped from a previous script)
      $variants_seq_url = $variants_seq_file;
      $variants_seq_url =~ s|$ENV{RSAT}/public_html|$ENV{rsat_www}|;
      $variants_seqChoiceString .=  "<a href=".$variants_seq_url.">";
      $variants_seqChoiceString .=  " transferred from previous query<BR>\n";
      $variants_seqChoiceString .=  "</a>";
      $variants_seqChoiceString .=  "<INPUT type='hidden' NAME='variants_seq_file' VALUE='".$variants_seq_file."'>\n";
      print $variants_seqChoiceString ;

  } else {
      print $query->textarea(-name=>'variants_seqs', -id=>'variants_seqs',
			     -default=>"",
			     -rows=>6,
			     -columns=>65);

      print "<br/>";
      print "<BR>Upload variant sequences<BR>\n";
      print $query->filefield(-name=>'uploaded_file',
			      -default=>'',
			      -size=>45,
			      -maxlength=>200);
      print "</UL>\n";
      print "<BR>\n";
  }
      print "</fieldset><p/>";
  print '</div><p class="clear"></p>';
}

##########################################
sub Panel3 {

################################################################
## Background model

    #my %bg_params =("markov" => 1,
#		    #"bg_input" => 1,
#		    "no_bg_pseudo" => 1,
#		    "markov_message" => 1
		    #"ensembl"=>1
#	);

print "<fieldset>
<legend><b><a href='help.convert-matrix.html#io_format'>Background </a></b></legend>";

my %bg_params =("markov" => 1,
		"bg_input" => 0,
		"markov_message" => 0,
		"no_bg_pseudo"=>1
	       );
&GetBackgroundModel(%bg_params);

print "</fieldset><p/>";


    print "<p/><fieldset>
<legend><b><a href='help.variation-scan.html#Scanning-parameters'>Scanning Parameters </a></b></legend>";
## Lenght of the sequences surranding the variant
    print "<B>Length of sequence around the variant</B>&nbsp;\n";
    print $query->textfield(-name=>'mml',
			    -default=>$default{mml},
			    -size=>5);

    ## Threshold table

  my $thresh_matches =
    $query->table({-border=>0,-cellpadding=>1,-cellspacing=>0},
		  $query->Tr({-align=>center,-valign=>MIDDLE},
			     [
			      $query->th([" <A HREF='help.variation-scan.html#Scanning-parameters'>Field</A> ",
					  " <A HREF='help.variation-scan.html#Scanning-parameters'>Lower<BR>Threshold</A> ",
					  " <A HREF='help.variation-scan.html#Scanning-parameters'>Upper<BR>Threshold</A>"]),

			      ### Threshold on weight score
			      $query->td(['Weight of predicted sites',
					  $query->textfield(-name=>'lth_score',
							    -default=>$default{lth_score},
							    -size=>5),
					  ""
					 ]),

			      ### Threshold on Sig of the score
			      $query->td(['Weight difference between variants',
					  $query->textfield(-name=>'lth_w_diff',
							    -default=>$default{lth_w_diff},
							    -size=>5),
					  ""
					 ]),

                              ### Threshold on P-value of the score
			      $query->td(['P-value of predicted sites',
					  "",
					  $query->textfield(-name=>'uth_pval',
							    -default=>$default{uth_pval},
							    -size=>5)
					 ]),

			      ### Threshold on P-value of the score
			      $query->td(['P-value ratio between variants',
					  $query->textfield(-name=>'lth_pval_ratio',
							    -default=>$default{lth_pval_ratio},
							    -size=>5),
					  ""
					 ]),


			     ]
			    )
		 );


    print "<br> <b>Thresholds </b> </br>";

    print "<td bgcolor='#F6E6CA'>$thresh_matches</td>";


    print "</p>";


    print "</fieldset><p/>";
}
