
package MyElements::compare_classes;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('compare_classes');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::CompareClassesRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::compare_classes

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
compare_classes from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::compare_classes->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::CompareClassesRequest
     output =>  $some_value, # string
     ref_classes =>  $some_value, # string
     query_classes =>  $some_value, # string
     return_fields =>  $some_value, # string
     score_column =>  $some_value, # int
     input_classes =>  $some_value, # string
     upper_threshold_field =>  $some_value, # string
     upper_threshold_value =>  $some_value, # string
     lower_threshold_field =>  $some_value, # string
     lower_threshold_value =>  $some_value, # string
     sort =>  $some_value, # string
     distinct =>  $some_value, # int
     triangle =>  $some_value, # int
     matrix =>  $some_value, # string
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

