
package MyElements::convert_graph;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('convert_graph');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::ConvertGraphRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::convert_graph

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
convert_graph from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::convert_graph->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::ConvertGraphRequest
     output =>  $some_value, # string
     informat =>  $some_value, # string
     ecolors =>  $some_value, # string
     outformat =>  $some_value, # string
     inputgraph =>  $some_value, # string
     wcol =>  $some_value, # int
     scol =>  $some_value, # int
     tcol =>  $some_value, # int
     eccol =>  $some_value, # int
     sccol =>  $some_value, # int
     tccol =>  $some_value, # int
     pathcol =>  $some_value, # int
     undirected =>  $some_value, # int
     distinct_path =>  $some_value, # int
     layout =>  $some_value, # int
     ewidth =>  $some_value, # int
     target_xpos_col =>  $some_value, # int
     target_ypos_col =>  $some_value, # int
     source_xpos_col =>  $some_value, # int
     source_ypos_col =>  $some_value, # int
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

