
package MyElements::pattern_assembly;
use strict;
use warnings;

{ # BLOCK to scope variables

sub get_xmlns { 'urn:RSATWS' }

__PACKAGE__->__set_name('pattern_assembly');
__PACKAGE__->__set_nillable();
__PACKAGE__->__set_minOccurs();
__PACKAGE__->__set_maxOccurs();
__PACKAGE__->__set_ref();

use base qw(
    SOAP::WSDL::XSD::Typelib::Element
    SOAP::WSDL::XSD::Typelib::ComplexType
);

our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %request_of :ATTR(:get<request>);

__PACKAGE__->_factory(
    [ qw(        request

    ) ],
    {
        'request' => \%request_of,
    },
    {
        'request' => 'MyTypes::PatternAssemblyRequest',
    },
    {

        'request' => 'request',
    }
);

} # end BLOCK






} # end of BLOCK



1;


=pod

=head1 NAME

MyElements::pattern_assembly

=head1 DESCRIPTION

Perl data type class for the XML Schema defined element
pattern_assembly from the namespace urn:RSATWS.





=head1 METHODS

=head2 new

 my $element = MyElements::pattern_assembly->new($data);

Constructor. The following data structure may be passed to new():

 {
   request =>  { # MyTypes::PatternAssemblyRequest
     output =>  $some_value, # string
     input =>  $some_value, # string
     tmp_infile =>  $some_value, # string
     verbosity =>  $some_value, # int
     score_col =>  $some_value, # int
     str =>  $some_value, # int
     maxfl =>  $some_value, # int
     subst =>  $some_value, # int
     max_asmb_nb =>  $some_value, # int
     max_asmb_size =>  $some_value, # int
     maxpat =>  $some_value, # int
     toppat =>  $some_value, # int
   },
 },

=head1 AUTHOR

Generated by SOAP::WSDL

=cut

