package MyTypes::ClassFreqRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %inputFile_of :ATTR(:get<inputFile>);
my %classinterval_of :ATTR(:get<classinterval>);
my %col_of :ATTR(:get<col>);
my %min_of :ATTR(:get<min>);
my %max_of :ATTR(:get<max>);
my %from_of :ATTR(:get<from>);
my %to_of :ATTR(:get<to>);

__PACKAGE__->_factory(
    [ qw(        output
        inputFile
        classinterval
        col
        min
        max
        from
        to

    ) ],
    {
        'output' => \%output_of,
        'inputFile' => \%inputFile_of,
        'classinterval' => \%classinterval_of,
        'col' => \%col_of,
        'min' => \%min_of,
        'max' => \%max_of,
        'from' => \%from_of,
        'to' => \%to_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'inputFile' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'classinterval' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'col' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'min' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'max' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'from' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'to' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'output' => 'output',
        'inputFile' => 'inputFile',
        'classinterval' => 'classinterval',
        'col' => 'col',
        'min' => 'min',
        'max' => 'max',
        'from' => 'from',
        'to' => 'to',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::ClassFreqRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
ClassFreqRequest from the namespace urn:RSATWS.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * inputFile


=item * classinterval


=item * col


=item * min


=item * max


=item * from


=item * to




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::ClassFreqRequest
   output =>  $some_value, # string
   inputFile =>  $some_value, # string
   classinterval =>  $some_value, # string
   col =>  $some_value, # string
   min =>  $some_value, # string
   max =>  $some_value, # string
   from =>  $some_value, # string
   to =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

