package MyTypes::GeneInfoRequest;
use strict;
use warnings;


our $XML_ATTRIBUTE_CLASS;
undef $XML_ATTRIBUTE_CLASS;

sub __get_attr_class {
    return $XML_ATTRIBUTE_CLASS;
}

use Class::Std::Fast::Storable constructor => 'none';
use base qw(SOAP::WSDL::XSD::Typelib::ComplexType);

Class::Std::initialize();

{ # BLOCK to scope variables

my %output_of :ATTR(:get<output>);
my %organism_of :ATTR(:get<organism>);
my %query_of :ATTR(:get<query>);
my %full_of :ATTR(:get<full>);
my %noquery_of :ATTR(:get<noquery>);
my %descr_of :ATTR(:get<descr>);
my %feattype_of :ATTR(:get<feattype>);

__PACKAGE__->_factory(
    [ qw(        output
        organism
        query
        full
        noquery
        descr
        feattype

    ) ],
    {
        'output' => \%output_of,
        'organism' => \%organism_of,
        'query' => \%query_of,
        'full' => \%full_of,
        'noquery' => \%noquery_of,
        'descr' => \%descr_of,
        'feattype' => \%feattype_of,
    },
    {
        'output' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'organism' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'query' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
        'full' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'noquery' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'descr' => 'SOAP::WSDL::XSD::Typelib::Builtin::int',
        'feattype' => 'SOAP::WSDL::XSD::Typelib::Builtin::string',
    },
    {

        'output' => 'output',
        'organism' => 'organism',
        'query' => 'query',
        'full' => 'full',
        'noquery' => 'noquery',
        'descr' => 'descr',
        'feattype' => 'feattype',
    }
);

} # end BLOCK







1;


=pod

=head1 NAME

MyTypes::GeneInfoRequest

=head1 DESCRIPTION

Perl data type class for the XML Schema defined complexType
GeneInfoRequest from the namespace urn:RSATWS.






=head2 PROPERTIES

The following properties may be accessed using get_PROPERTY / set_PROPERTY
methods:

=over

=item * output


=item * organism


=item * query


=item * full


=item * noquery


=item * descr


=item * feattype




=back


=head1 METHODS

=head2 new

Constructor. The following data structure may be passed to new():

 { # MyTypes::GeneInfoRequest
   output =>  $some_value, # string
   organism =>  $some_value, # string
   query =>  $some_value, # string
   full =>  $some_value, # int
   noquery =>  $some_value, # int
   descr =>  $some_value, # int
   feattype =>  $some_value, # string
 },




=head1 AUTHOR

Generated by SOAP::WSDL

=cut

